<template>
  <section editor>
    <template v-if="editorOpenFullscreen">
      <rowEditor :key="lastKeyPath.key" :keyEntry="lastKeyPath" :keyIndex="editorRows.length - 1"/>
    </template>
    <template v-else>
      <rootKeyList v-if="$store.state.editor.keyPath[0]" @rootkeyselected="setRootKey" :activeValue="$store.state.editor.keyPath[0].key"/>
      <rowEditor v-for="(keyPath, index) in editorRows" :key="keyPath.key" :keyEntry="keyPath" :keyIndex="index"/>

      <md-app-toolbar class="md-primary" md-elevation="0" v-if="!editorOpen"/>
    </template>
  </section>
</template>

<script lang="ts">
import { Component, Vue } from 'vue-property-decorator';
import { store } from '../store';

import rootKeyList from '../components/editor/rootKeyList.vue';
import rowEditor from '../components/editor/rowEditor.vue';
import { KeyPathKey } from '../store/editor';

@Component({
  components: {
    rootKeyList,
    rowEditor,
  },
})
export default class extends Vue {
  get editorRows() {
    return store.state.editor.keyPath.filter(entry => entry.key);
  }

  get editorOpen(): boolean {
    const keyPath = store.state.editor.keyPath;
    if (!keyPath || keyPath.length === 0) {
      return false;
    }
    const lastKeyPath = keyPath[keyPath.length - 1];
    return !!lastKeyPath.options.clob;
  }

  get editorOpenFullscreen(): boolean {
    const keyPath = store.state.editor.keyPath;
    if (!keyPath || keyPath.length === 0) {
      return false;
    }
    const lastKeyPath = keyPath[keyPath.length - 1];
    return !!lastKeyPath.options.clob && !!lastKeyPath.options.fullscreen;
  }

  get lastKeyPath() {
    return this.editorRows[this.editorRows.length - 1];
  }


  private setRootKey(id: string) {
    const firstKeyPath = store.state.editor.keyPath[0];
    if (firstKeyPath.key !== id) {
      const keyPath: KeyPathKey[] = [{
        tableName: firstKeyPath.tableName,
        key: id,
        options: {},
      }];
      store.commit.editor('setKeyPath', keyPath);
    }
  }
}
</script>

<style scoped lang="scss">
[editor] {
  display: flex;
  flex-direction: row;
  height: 100%;
  align-items: flex-start;
}
</style>
